"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProcessInteraction = exports.ProcessEvaluationPlan = exports.ProcessAudios = exports.ProcessAudioTranscription = exports.ProcessAudio = exports.LinguisticProcessStatus = exports.ProcessSummary = exports.ProcessFilter = exports.Process = void 0;
var Process = (function () {
    function Process(vcc, name, description, clientId, status, type, startDate, endDate, minDurationTime, maxDurationTime, environment, environmentType, queryId, queryDataId, queryDataIdDate, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.vcc = vcc;
        this.name = name;
        this.description = description;
        this.clientId = clientId;
        this.status = status;
        this.type = type;
        this.startDate = startDate;
        this.endDate = endDate;
        this.minDurationTime = minDurationTime;
        this.maxDurationTime = maxDurationTime;
        this.environment = environment;
        this.environmentType = environmentType;
        this.queryId = queryId;
        this.queryDataId = queryDataId;
        this.queryDataIdDate = queryDataIdDate;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.processType = null;
        this.selected = false;
        this.start = false;
        this.processFilters = [];
        this.dictionaryId = null;
        this.batchScheduleId = null;
        this.scheduleData = null;
    }
    return Process;
}());
exports.Process = Process;
var ProcessFilter = (function () {
    function ProcessFilter(processId, key, value, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.processId = processId;
        this.key = key;
        this.value = value;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
        this.selected = false;
    }
    return ProcessFilter;
}());
exports.ProcessFilter = ProcessFilter;
var ProcessSummary = (function () {
    function ProcessSummary(vcc, processId, silenceTime, averageSilenceTime, durationTime, averageDurationTime, durationTimeRate, validDurationTime) {
        this.vcc = vcc;
        this.processId = processId;
        this.silenceTime = silenceTime;
        this.averageSilenceTime = averageSilenceTime;
        this.durationTime = durationTime;
        this.averageDurationTime = averageDurationTime;
        this.durationTimeRate = durationTimeRate;
        this.validDurationTime = validDurationTime;
    }
    return ProcessSummary;
}());
exports.ProcessSummary = ProcessSummary;
var LinguisticProcessStatus = (function () {
    function LinguisticProcessStatus(vcc, processId, status, toTranscribe, transcribed, percentage) {
        this.vcc = vcc;
        this.processId = processId;
        this.status = status;
        this.toTranscribe = toTranscribe;
        this.transcribed = transcribed;
        this.percentage = percentage;
    }
    return LinguisticProcessStatus;
}());
exports.LinguisticProcessStatus = LinguisticProcessStatus;
var ProcessAudio = (function () {
    function ProcessAudio(id, number, name, processId, silennceTime, durationTime, category1, category2, category3, agent, description, environment, createdDate) {
        this.id = id;
        this.number = number;
        this.name = name;
        this.processId = processId;
        this.silennceTime = silennceTime;
        this.durationTime = durationTime;
        this.category1 = category1;
        this.category2 = category2;
        this.category3 = category3;
        this.agent = agent;
        this.description = description;
        this.environment = environment;
        this.createdDate = createdDate;
    }
    return ProcessAudio;
}());
exports.ProcessAudio = ProcessAudio;
var ProcessAudioTranscription = (function () {
    function ProcessAudioTranscription(id, section, number, processId, silennceTime, durationTime, durationLinguisticTime, category1, category2, category3, agent, description, environment, environmentType, isTranscribed, isSubrayed, createdDate) {
        this.id = id;
        this.section = section;
        this.number = number;
        this.processId = processId;
        this.silennceTime = silennceTime;
        this.durationTime = durationTime;
        this.durationLinguisticTime = durationLinguisticTime;
        this.category1 = category1;
        this.category2 = category2;
        this.category3 = category3;
        this.agent = agent;
        this.description = description;
        this.environment = environment;
        this.environmentType = environmentType;
        this.isTranscribed = isTranscribed;
        this.isSubrayed = isSubrayed;
        this.createdDate = createdDate;
    }
    return ProcessAudioTranscription;
}());
exports.ProcessAudioTranscription = ProcessAudioTranscription;
var ProcessAudios = (function () {
    function ProcessAudios(vcc, processId, audioId, section, part, createdDate, createdByUserId, lastModifiedDate, lastModifiedByUserId) {
        this.vcc = vcc;
        this.processId = processId;
        this.audioId = audioId;
        this.section = section;
        this.part = part;
        this.createdDate = createdDate;
        this.createdByUserId = createdByUserId;
        this.lastModifiedDate = lastModifiedDate;
        this.lastModifiedByUserId = lastModifiedByUserId;
    }
    return ProcessAudios;
}());
exports.ProcessAudios = ProcessAudios;
var ProcessEvaluationPlan = (function () {
    function ProcessEvaluationPlan() {
        this.evaluationFormatId = null;
    }
    return ProcessEvaluationPlan;
}());
exports.ProcessEvaluationPlan = ProcessEvaluationPlan;
var ProcessInteraction = (function () {
    function ProcessInteraction(vcc, processId, id) {
        this.vcc = vcc;
        this.processId = processId;
        this.id = id;
        this.relativePath = null;
        this.dictionaryId = null;
        this.isDiariced = false;
        this.channelsChanged = false;
    }
    return ProcessInteraction;
}());
exports.ProcessInteraction = ProcessInteraction;
